DECLARE SUB ShowCredits ()
DECLARE SUB Spread (text$, Row%, Col%, Delay%)
'
'           Q B a s i c   N i b b l e s  ME (Millennium Edition V1.0)
'
'                  Copyright (C) Microsoft Corporation 1990
'           Millennium Edition Features (C) PZ & Thomas Antoni 2000
'
' Nibbles is a game for one or two players.  Navigate your snakes
' around the game board trying to eat up numbers while avoiding
' running into walls or other snakes.  The more numbers you eat up,
' the more points you gain and the longer your snake becomes.
'
' To run this game, press Shift+F5.
'
' To exit QBasic, press Alt, F, X.
'
' To get help on a BASIC keyword, move the cursor to the keyword and press
' F1 or click the right mouse button.
'

'Set default data type to integer for faster game play
DEFINT A-Z

'User-defined TYPEs

'---------- Insertion 7a) Antoni for TOP46 ---------------------------------
TYPE hiscore                         'Anwenderspezifischen Datentyp
                                     '"Hiscore-Eintrag" deklarieren
  rank AS INTEGER                    'Platz in der Bestenliste (2 Bytes)
  nam AS STRING * 14                 'Name des Spielers
  points AS LONG                     'Punkte (4 Bytes, max. 9999999)
  date AS STRING * 8                 'Datum
END TYPE                             'Gesamtlnge e.Datensatzes= 2+14+4+8
                                     '=28 Bytes
'----------- End of Insertion 7a) by Antoni ---------------------------------

TYPE snakeBody
    Row AS INTEGER
    Col AS INTEGER
END TYPE

'This type defines the player's snake
TYPE snaketype
    head      AS INTEGER
    length    AS INTEGER
    Row       AS INTEGER
    Col       AS INTEGER
    direction AS INTEGER
    lives     AS INTEGER
    score     AS INTEGER
    scolor    AS INTEGER
    alive     AS INTEGER
END TYPE

TYPE arenaType
    realRow     AS INTEGER        'Maps the 80x50 point into the real 80x25
    acolor      AS INTEGER        'Stores the current color of the point
    sister      AS INTEGER        'Each char has 2 points in it.  .SISTER is
END TYPE                          '-1 if sister point is above, +1 if below

'Sub Declarations
DECLARE SUB center (Row, text$)
DECLARE SUB ChangeColor (n%, r%, g%, b%)
DECLARE SUB cursor (z%)
DECLARE SUB DrawScreen ()
DECLARE SUB EraseSnake (snake() AS ANY, snakeBod() AS ANY, snakeNum%)
DECLARE SUB GetInput (NumPlayers%, xlr8, monitor)
DECLARE SUB HelpScreen ()
DECLARE SUB InitColors ()
DECLARE SUB Level (WhatToDO, sammy() AS snaketype)
DECLARE SUB PrintScore (NumPlayers%, score1%, score2%, lives1%, lives2%)
DECLARE SUB InitNoise (n%)
DECLARE SUB Intro ()
DECLARE SUB PlayNibbles (NumPlayers, xlr8)
DECLARE SUB ReadConfigFile ()
DECLARE SUB saveconfig (a, b$)
DECLARE SUB Set (Row, Col, acolor)
DECLARE SUB SetColors (m%)
DECLARE SUB SpacePause (text$)
DECLARE SUB SparklePause ()
DECLARE SUB twinkle ()
DECLARE FUNCTION StillWantsToPlay ()
DECLARE FUNCTION PointIsThere (Row, Col, backColor)
DECLARE SUB Top46 (score&, hiscoreonly%, playerno%) 'Highscore Generator eingefgt Antoni

CLEAR : ChangeColor -1, 0, 0, 0

'Constants
CONST TRUE = -1
CONST FALSE = NOT TRUE
CONST MAXSNAKELENGTH = 1000
CONST STARTOVER = 1             ' Parameters to 'Level' SUB
CONST SAMELEVEL = 2
CONST NEXTLEVEL = 3

'Global Variables
DIM SHARED arena(1 TO 50, 1 TO 80) AS arenaType
DIM SHARED curLevel, colortable(1 TO 6)
DIM SHARED config(1 TO 6) AS STRING * 14
DIM SHARED name1$, name2$
DIM SHARED noise(1 TO 6) AS STRING
DIM SHARED rspeed AS INTEGER


    RANDOMIZE TIMER
'    GOSUB ClearKeyLocks
    ReadConfigFile
    Intro
    GetInput NumPlayers, xlr8, monitor
    DrawScreen

    DO
      PlayNibbles NumPlayers, xlr8
    LOOP WHILE StillWantsToPlay

'    GOSUB RestoreKeyLocks
    COLOR 15, 0
    CLS
'END
SYSTEM

ClearKeyLocks:
    DEF SEG = 0                     ' Turn off CapLock, NumLock and ScrollLock
    KeyFlags = PEEK(1047)
    POKE 1047, &H0
    DEF SEG
    RETURN

RestoreKeyLocks:
    DEF SEG = 0                     ' Restore CapLock, NumLock and ScrollLock states
    POKE 1047, KeyFlags
    DEF SEG
    RETURN

END

'Center:
'  Centers text on given row
SUB center (Row, text$)
'   LOCATE row, 41 - LEN(text$) / 2
    LOCATE Row, 41 - LEN(text$) \ 2
    PRINT text$;
END SUB

SUB ChangeColor (number, red, green, blue)

'---------------------------------------------------------------------------
' Changes the default background colours by calling Interrupt 10h (1010h)
' Colours (0...7) may be redefined by three values (red / green / blue)
' in the range from 0 to 63
' Call ChangeColor (-1, 0, 0, 0) to reset colors
'---------------------------------------------------------------------------
' version 0.1                                  created by pz / 13.09.2000
'---------------------------------------------------------------------------

asmcode$ = ")"                    '14 bytes assembled code

SELECT CASE number
        CASE IS < 0                            'reset Colors:
                SCREEN 0, 0: SCREEN 0, 1       'this has to be
                EXIT SUB                       'modified for another
        CASE IS > 7                            'screen mode than 0
                EXIT SUB
END SELECT

MID$(asmcode$, 5, 1) = CHR$(number)
MID$(asmcode$, 7, 1) = CHR$(red)
MID$(asmcode$, 9, 1) = CHR$(blue)
MID$(asmcode$, 11, 1) = CHR$(green)

CALL absolute(SADD(asmcode$))

END SUB

'-------------------------------------- Setzt den Cursor in der Eingabemaske
'-------------------------------------- Schreibt Statuszeile ---------------
SUB cursor (zeile)
STATIC z0, z1 AS INTEGER
IF z0 = 0 THEN z0 = zeile
z1 = zeile
COLOR 0, 0: LOCATE z0, 22: PRINT ""; : LOCATE z0, 39: PRINT "";
COLOR 12, 0: LOCATE z1, 22: PRINT ""; : LOCATE z1, 39: PRINT "";
z0 = z1
COLOR 14, 0: LOCATE 23, 10, 0

SELECT CASE zeile
CASE IS = 9
PRINT " Name des ersten Spielers       ";
CASE IS = 11
PRINT " Spieler 2 | - fr Einzelspiel  ";
CASE IS = 13
PRINT " Speed 1 ... 10 ... ?           ";
CASE IS = 15
PRINT " Autoincrease 0 | 1             ";
CASE IS = 17
PRINT " 0 = No Sound | 1 | 2           ";
CASE IS = 19
PRINT " Colours 0 | 1 | 2              ";
CASE IS = 21
PRINT " Start Game by <Enter>          ";
END SELECT

COLOR 15, 0
END SUB

'DrawScreen:
'  Draws playing field
SUB DrawScreen

    'initialize screen
    VIEW PRINT
   
    COLOR colortable(1), colortable(4)
    CLS

    'Print title & message
    center 1, "Nibbles!"
    center 11, "Initializing Playing Field..."

    'Initialize arena array
    FOR Row = 1 TO 50
        FOR Col = 1 TO 80
            arena(Row, Col).realRow = INT((Row + 1) / 2)
            arena(Row, Col).sister = (Row MOD 2) * 2 - 1
        NEXT Col
    NEXT Row
END SUB

'EraseSnake:
'  Erases snake to facilitate moving through playing field
SUB EraseSnake (snake() AS snaketype, snakeBod() AS snakeBody, snakeNum)

    FOR c = 0 TO 9
        FOR b = snake(snakeNum).length - c TO 0 STEP -10
            tail = (snake(snakeNum).head + MAXSNAKELENGTH - b) MOD MAXSNAKELENGTH
            Set snakeBod(tail, snakeNum).Row, snakeBod(tail, snakeNum).Col, colortable(4)
        NEXT b
    NEXT c

END SUB

SUB GetInput (NumPlayers, xlr8, monitor)

'---------------------------------------------------------- Hintergrund -----
'COLOR 3, 1
'LOCATE 1, 1: PRINT STRING$(80, 32);
'  FOR i = 2 TO 24
'  LOCATE i, 1: PRINT STRING$(80, 177);
'  NEXT
'LOCATE 25, 1: PRINT STRING$(80, 32);

'------------------------------------------------- Variante Hintergrund -----
DEF SEG = &HB800
  FOR i = 1 TO 3999 STEP 2: POKE i, 120: NEXT             'Colour
  FOR i = 0 TO 3998 STEP 18                               'Characters
    POKE i, 78: POKE i + 2, 105: POKE i + 4, 98
    POKE i + 6, 98: POKE i + 8, 108: POKE i + 10, 101
    POKE i + 12, 115: POKE i + 14, 33: POKE i + 16, 32
  NEXT
DEF SEG

'---------------------------------------------------------- Eingabefeld -----
COLOR 15, 0
FOR i = 1 TO 16 STEP 2
  LOCATE i + 6, 10: PRINT STRING$(32, 32);
NEXT

LOCATE 7, 11: COLOR 14: PRINT "Configuration": COLOR 15
LOCATE 9, 11: PRINT "Player 1"
LOCATE 11, 11: PRINT "Player 2"
LOCATE 13, 11: PRINT "Speed"
LOCATE 15, 11: PRINT "AutoInc."
LOCATE 17, 11: PRINT "Sounds"
LOCATE 19, 11: PRINT "Colours"

LOCATE 9, 25: PRINT config(1)
LOCATE 11, 25: PRINT config(2)
LOCATE 13, 25: PRINT config(3)
LOCATE 15, 25: PRINT config(4)
LOCATE 17, 25: PRINT config(5)
LOCATE 19, 25: PRINT config(6)
LOCATE 21, 25: PRINT "    Start    "

'---------------------------------------------------------- Eingabeschleife--
zeile = 21
cursor (zeile)
DO
twinkle
taste$ = INKEY$
IF taste$ <> "" THEN

  SELECT CASE taste$
'---------------------------------------------------------- Up / Down ------
    CASE IS = CHR$(0) + CHR$(73)
                saveconfig zeile, eingabe$
                eingabe$ = "": zeile = 9
    CASE IS = CHR$(0) + CHR$(81)
                saveconfig zeile, eingabe$
                eingabe$ = "": zeile = 21
    CASE IS = CHR$(0) + CHR$(72)
                saveconfig zeile, eingabe$
                eingabe$ = "": zeile = zeile - 2
    CASE IS = CHR$(0) + CHR$(80)
                saveconfig zeile, eingabe$
                eingabe$ = "": zeile = zeile + 2

'---------------------------------------------------------- Delete Taste ---
    CASE IS = CHR$(0) + CHR$(83)
                LOCATE zeile, 25: PRINT STRING$(15, 32);
                eingabe$ = ""

'---------------------------------------------------------- Eingabetaste ---
    CASE IS = CHR$(13)
                IF zeile = 21 THEN EXIT DO
                saveconfig zeile, eingabe$
                eingabe$ = "": zeile = zeile + 2

'---------------------------------------------------------- Escapetaste ----
    CASE IS = CHR$(27)
                IF eingabe$ = "" THEN SYSTEM
                eingabe$ = ""
                LOCATE zeile, 25: PRINT STRING$(15, 32);

'---------------------------------------------------------- Rcktaste ------
    CASE IS = CHR$(8)
                IF eingabe$ > "" THEN
                eingabe$ = LEFT$(eingabe$, LEN(eingabe$) - 1)
                LOCATE zeile, 25: PRINT ; eingabe$ + " ";
                END IF
'---------------------------------------------------------- F1 -------------
    CASE IS = CHR$(0) + CHR$(59)
                HelpScreen
               

    CASE ELSE
'------------------------------------------- Zeichenkette bilden + anzeigen -
                IF taste$ >= CHR$(32) AND taste$ < CHR$(154) AND NOT zeile = 21 THEN
                eingabe$ = eingabe$ + taste$
                LOCATE zeile, 25: PRINT STRING$(15, 32);
                LOCATE zeile, 25: PRINT eingabe$;
                END IF

  END SELECT

'---------------------------------------------------------- Eingabemarke ----
  SELECT CASE zeile
    CASE IS > 21: zeile = 9
    CASE IS < 9: zeile = 21
  END SELECT

  cursor (zeile)

END IF

LOOP

'----------------------------------------------------------------------------
name1$ = RTRIM$(config(1))
name2$ = RTRIM$(config(2))
speedin = ABS(VAL(config(3)))
xlr8 = -1 * SGN(VAL(config(4)))

InitNoise VAL(config(5))
SetColors VAL(config(6))

NumPlayers = 2: IF name2$ = "-" THEN NumPlayers = 1

'----------------------------------------------------- Write INI-File ----
nr = FREEFILE
OPEN "nibblesM.ini" FOR BINARY AS #nr
FOR i = 1 TO 6: PUT #nr, , config(i): NEXT
CLOSE (nr)
 

'----------------------------------------------------- Speed Check ------

'    StartTime# = TIMER                          ' Calculate speed of
'    FOR i# = 1 TO 1000: NEXT i#                 ' stone aged systems
'    StopTime# = TIMER                           ' by counting

    
     LOCATE 21, 25, 0: PRINT " Please Wait ";
     COLOR 14, 0
     LOCATE 23, 10, 0: PRINT " Speed Check Running ... ";

     StartTime# = TIMER                          ' Calculate speed of system
       FOR i# = 1 TO 5000                        ' by measuring time for
       center 1, LEFT$(TIME$, 5)                 ' screen output
       NEXT i#
     StopTime# = TIMER

     IF (StopTime# - StartTime#) = 0 THEN rspeed = 1500: EXIT SUB
     rspeed = (1000 / (StopTime# - StartTime#) + 1500 - 120 * (StopTime# - StartTime#)) / (speedin + 1)
     IF rspeed < 0 THEN rspeed = 0

END SUB

SUB HelpScreen
SCREEN 0, 1, 1, 1                                  'Change page

        center 5, "There is no help available"
        center 7, "Feel free to write some help text."
        center 17, "Press any key to continue Nibbles"
        DO: LOOP WHILE INKEY$ = ""

SCREEN 0, 1, 0, 0                                  'Back to page 0
END SUB

'InitColors:
'Initializes playing field colors
SUB InitColors

    FOR Row = 1 TO 50
        FOR Col = 1 TO 80
            arena(Row, Col).acolor = colortable(4)
        NEXT Col
    NEXT Row

    CLS

    'Set (turn on) pixels for screen border
    FOR Col = 1 TO 80
        Set 3, Col, colortable(3)
        Set 50, Col, colortable(3)
    NEXT Col

    FOR Row = 4 TO 49
        Set Row, 1, colortable(3)
        Set Row, 80, colortable(3)
    NEXT Row

END SUB

SUB InitNoise (noisy)                           'selects sounds

SELECT CASE noisy

  CASE 0                                        'beneficent silence
        FOR i = 1 TO 6
        noise(i) = ""
        NEXT

  CASE 1                                        'microsoft nibbles sounds
        noise(1) = "MBT160O1L8CDEDCDL4ECC"      'intro
        noise(2) = "MBT160O1>L20CDEDCDL10ECC"   'run
        noise(3) = "MBO0L16>CCCE"               'eat
        noise(4) = "MBO0L32EFGEFDC"             'die

                                                'added by thomas antoni
        noise(5) = "MBT240L64MLO4CECECECECECECADADADADADADADADADFGFGFGFGFGFGFG"
        noise(6) = "MBO0L32cdcdcdcdcdcdcdcdcdcdcd"

  CASE 2
        noise(1) = "MBT160O1L8CDEDCDL4ECC"
        noise(2) = "T160O1>L20CDEDCDL10ECC"
        noise(3) = "MBT255L64MLO4BCADGEFEGDACBCADGEFEGDACB"  'antoni's devouring song
        noise(4) = "T150L64MSO4BFC<GD<AL16E"                 'antoni's funeral song
        noise(5) = "MBT240L64MLO4CECECECECECECADADADADADADADADADFGFGFGFGFGFGFG"
                                                             'antoni's jubilation song
        noise(6) = "MBO0L32cdcdcdcdcdcdcdcdcdcdcd"           'antoni's dirge

  CASE ELSE
        noise(1) = "MBT255L8<AL4>DL8<AL4>DL8EL4FL8EL4D."     'trara, das tnt
        noise(2) = "MBT255L8<AL4>DL8<AL4>DL8EL4FL8EL4D."     'wie Jagdgesang
        noise(3) = "MBT255<L16AB.AB>"                        '
        noise(4) = "MBT255<L16BACBAC>"                       '   just any
        noise(5) = "MBT255<L16DADADADA.>"                    '     noise
        noise(6) = "MBT255<<L4GGGC.>>"                       '

END SELECT

'---- Nummernfressen-Sound gendert, T.Antoni, 25.6.99 ; pz, 08.09.2000
'---- Sterbesound gendert, T.Antoni, 25.6.99

END SUB

'Intro:
'  Displays game introduction
SUB Intro
    SCREEN 0: WIDTH 80, 25
    CLS
'************* Millennum features added (c)T.Antoni, 2000 ************
    COLOR 15, 0: center 4, "Q B a s i c   N i b b l e s  ME (Millennium Edition)": COLOR 7, 0

    center 6, "Copyright (C) Microsoft Corporation 1990"
    center 7, "Millennium Edition Features (C) PZ & Thomas Antoni 2000"
    center 9, "Nibbles is a game for one or two players.  Navigate your snakes"
    center 10, "around the game board trying to eat up numbers while avoiding"
    center 11, "running into walls or other snakes.  The more numbers you eat up,"
    center 12, "the more points you gain and the longer your snake becomes."
    center 14, " Game Controls "
    center 16, "  General             Player 1               Player 2    "
    center 17, "                        (Up)                   (Up)      "
    center 18, "P - Pause                " + CHR$(24) + "                      W       "
    center 19, "                     (Left) " + CHR$(27) + "   " + CHR$(26) + " (Right)   (Left) A   D (Right)  "
    center 20, "                         " + CHR$(25) + "                      S       "
    center 21, "                       (Down)                 (Down)     "

'************** Insertion (c) Thomas Antoni ***********************************
    COLOR 14 'yellow text
    LOCATE 22
    PRINT "       Press <F1> ";
    CALL Spread("for more information on the Nibbles Millenium Edition", CSRLIN, 46, 1)
    COLOR 7, 0
'************** End of Insertin (c) Thomas Antoni ***************************
  
    center 24, "........... Press any key to continue"

    PLAY noise(1)
    SparklePause

END SUB

'Level:
'Sets game level
SUB Level (WhatToDO, sammy() AS snaketype) STATIC

    SELECT CASE (WhatToDO)

    CASE STARTOVER
        curLevel = 1
    CASE NEXTLEVEL
        curLevel = curLevel + 1
    END SELECT

    sammy(1).head = 1                       'Initialize Snakes
    sammy(1).length = 2
    sammy(1).alive = TRUE
    sammy(2).head = 1
    sammy(2).length = 2
    sammy(2).alive = TRUE

    InitColors

    SELECT CASE curLevel
    CASE 1
        sammy(1).Row = 25: sammy(2).Row = 25
        sammy(1).Col = 50: sammy(2).Col = 30
        sammy(1).direction = 4: sammy(2).direction = 3


    CASE 2
        FOR i = 20 TO 60
            Set 25, i, colortable(3)
        NEXT i
        sammy(1).Row = 7: sammy(2).Row = 43
        sammy(1).Col = 60: sammy(2).Col = 20
        sammy(1).direction = 3: sammy(2).direction = 4

    CASE 3
        FOR i = 10 TO 40
            Set i, 20, colortable(3)
            Set i, 60, colortable(3)
        NEXT i
        sammy(1).Row = 25: sammy(2).Row = 25
        sammy(1).Col = 50: sammy(2).Col = 30
        sammy(1).direction = 1: sammy(2).direction = 2

    CASE 4
        FOR i = 4 TO 30
            Set i, 20, colortable(3)
            Set 53 - i, 60, colortable(3)
        NEXT i
        FOR i = 2 TO 40
            Set 38, i, colortable(3)
            Set 15, 81 - i, colortable(3)
        NEXT i
        sammy(1).Row = 7: sammy(2).Row = 43
        sammy(1).Col = 60: sammy(2).Col = 20
        sammy(1).direction = 3: sammy(2).direction = 4

    CASE 5
        FOR i = 13 TO 39
            Set i, 21, colortable(3)
            Set i, 59, colortable(3)
        NEXT i
        FOR i = 23 TO 57
            Set 11, i, colortable(3)
            Set 41, i, colortable(3)
        NEXT i
        sammy(1).Row = 25: sammy(2).Row = 25
        sammy(1).Col = 50: sammy(2).Col = 30
        sammy(1).direction = 1: sammy(2).direction = 2

    CASE 6
        FOR i = 4 TO 49
            IF i > 30 OR i < 23 THEN
                Set i, 10, colortable(3)
                Set i, 20, colortable(3)
                Set i, 30, colortable(3)
                Set i, 40, colortable(3)
                Set i, 50, colortable(3)
                Set i, 60, colortable(3)
                Set i, 70, colortable(3)
            END IF
        NEXT i
        sammy(1).Row = 7: sammy(2).Row = 43
        sammy(1).Col = 65: sammy(2).Col = 15
        sammy(1).direction = 2: sammy(2).direction = 1

    CASE 7
        FOR i = 4 TO 49 STEP 2
            Set i, 40, colortable(3)
        NEXT i
        sammy(1).Row = 7: sammy(2).Row = 43
        sammy(1).Col = 65: sammy(2).Col = 15
        sammy(1).direction = 2: sammy(2).direction = 1

    CASE 8
        FOR i = 4 TO 40
            Set i, 10, colortable(3)
            Set 53 - i, 20, colortable(3)
            Set i, 30, colortable(3)
            Set 53 - i, 40, colortable(3)
            Set i, 50, colortable(3)
            Set 53 - i, 60, colortable(3)
            Set i, 70, colortable(3)
        NEXT i
        sammy(1).Row = 7: sammy(2).Row = 43
        sammy(1).Col = 65: sammy(2).Col = 15
        sammy(1).direction = 2: sammy(2).direction = 1

    CASE 9
        FOR i = 6 TO 47
            Set i, i, colortable(3)
            Set i, i + 28, colortable(3)
        NEXT i
        sammy(1).Row = 40: sammy(2).Row = 15
        sammy(1).Col = 75: sammy(2).Col = 5
        sammy(1).direction = 1: sammy(2).direction = 2

    CASE ELSE
        FOR i = 4 TO 49 STEP 2
            Set i, 10, colortable(3)
            Set i + 1, 20, colortable(3)
            Set i, 30, colortable(3)
            Set i + 1, 40, colortable(3)
            Set i, 50, colortable(3)
            Set i + 1, 60, colortable(3)
            Set i, 70, colortable(3)
        NEXT i
        sammy(1).Row = 7: sammy(2).Row = 43
        sammy(1).Col = 65: sammy(2).Col = 15
        sammy(1).direction = 2: sammy(2).direction = 1

    END SELECT
END SUB

'PlayNibbles:
'  Main routine that controls game play
SUB PlayNibbles (NumPlayers, xlr8)
    'Initialize Snakes
    DIM sammyBody(MAXSNAKELENGTH - 1, 1 TO 2) AS snakeBody
    DIM sammy(1 TO 2) AS snaketype
    sammy(1).lives = 5
    sammy(1).score = 0
    sammy(1).scolor = colortable(1)
    sammy(2).lives = 5
    sammy(2).score = 0
    sammy(2).scolor = colortable(2)

    Level STARTOVER, sammy()
    startRow1 = sammy(1).Row: startCol1 = sammy(1).Col
    startRow2 = sammy(2).Row: startCol2 = sammy(2).Col

    CurSpeed = rspeed

    'play Nibbles until finished

    SpacePause "Level" + STR$(curLevel) + "    Push Space"
    gameOver = FALSE
    DO
        IF NumPlayers = 1 THEN
            sammy(2).Row = 0
        END IF

        number = 1          'Current number that snakes are trying to run into
        nonum = TRUE        'nonum = TRUE if a number is not on the screen

        playerDied = FALSE
        PrintScore NumPlayers, sammy(1).score, sammy(2).score, sammy(1).lives, sammy(2).lives
        PLAY noise(2)

        DO
            'Print number if no number exists
            IF nonum = TRUE THEN
                DO
                    numberRow = INT(RND(1) * 47 + 3)
                    NumberCol = INT(RND(1) * 78 + 2)
                    sisterRow = numberRow + arena(numberRow, NumberCol).sister
                LOOP UNTIL NOT PointIsThere(numberRow, NumberCol, colortable(4)) AND NOT PointIsThere(sisterRow, NumberCol, colortable(4))
                numberRow = arena(numberRow, NumberCol).realRow
                nonum = FALSE
                COLOR colortable(1), colortable(4)
                LOCATE numberRow, NumberCol
                PRINT RIGHT$(STR$(number), 1);
                count = 0
            END IF

            'Delay game
            FOR a# = 1 TO CurSpeed
            COLOR colortable(3), colortable(4)
            center 1, " " + LEFT$(TIME$, 5) + " "     'Delay by screen output
            NEXT a#

            'Get keyboard input & Change direction accordingly
            kbd$ = INKEY$
            SELECT CASE kbd$
                CASE "w", "W": IF sammy(2).direction <> 2 THEN sammy(2).direction = 1
                CASE "s", "S": IF sammy(2).direction <> 1 THEN sammy(2).direction = 2
                CASE "a", "A": IF sammy(2).direction <> 4 THEN sammy(2).direction = 3
                CASE "d", "D": IF sammy(2).direction <> 3 THEN sammy(2).direction = 4
                CASE CHR$(0) + "H": IF sammy(1).direction <> 2 THEN sammy(1).direction = 1
                CASE CHR$(0) + "P": IF sammy(1).direction <> 1 THEN sammy(1).direction = 2
                CASE CHR$(0) + "K": IF sammy(1).direction <> 4 THEN sammy(1).direction = 3
                CASE CHR$(0) + "M": IF sammy(1).direction <> 3 THEN sammy(1).direction = 4
                CASE "p", "P": SpacePause " Game Paused ... Push Space "
                CASE CHR$(27): END
                CASE ELSE
            END SELECT

            FOR a = 1 TO NumPlayers
                'Move Snake
                SELECT CASE sammy(a).direction
                    CASE 1: sammy(a).Row = sammy(a).Row - 1
                    CASE 2: sammy(a).Row = sammy(a).Row + 1
                    CASE 3: sammy(a).Col = sammy(a).Col - 1
                    CASE 4: sammy(a).Col = sammy(a).Col + 1
                END SELECT

                'If snake hits number, respond accordingly
                IF numberRow = INT((sammy(a).Row + 1) / 2) AND NumberCol = sammy(a).Col THEN

                    PLAY noise(3)                       'Eat

                    IF sammy(a).length < (MAXSNAKELENGTH - 30) THEN
                        sammy(a).length = sammy(a).length + number * 4
                    END IF
                    sammy(a).score = sammy(a).score + number
                    PrintScore NumPlayers, sammy(1).score, sammy(2).score, sammy(1).lives, sammy(2).lives
                    number = number + 1
                    IF number = 10 THEN
                        EraseSnake sammy(), sammyBody(), 1
                        EraseSnake sammy(), sammyBody(), 2
                        LOCATE numberRow, NumberCol: PRINT " "
                        Level NEXTLEVEL, sammy()
                        PrintScore NumPlayers, sammy(1).score, sammy(2).score, sammy(1).lives, sammy(2).lives
                        SpacePause "Level" + STR$(curLevel) + "    Push Space"
                        IF NumPlayers = 1 THEN sammy(2).Row = 0
                        number = 1
                        IF xlr8 THEN rspeed = INT(rspeed * .85): CurSpeed = rspeed
                    END IF
                    nonum = TRUE
                    IF CurSpeed < 1 THEN CurSpeed = 1
                END IF
            NEXT a

            FOR a = 1 TO NumPlayers
                'If player runs into any point, or the head of the other snake, it dies.
                IF PointIsThere(sammy(a).Row, sammy(a).Col, colortable(4)) OR (sammy(1).Row = sammy(2).Row AND sammy(1).Col = sammy(2).Col) THEN

                    PLAY noise(4)                   'Die

                    COLOR , colortable(4)
                    LOCATE numberRow, NumberCol
                    PRINT " "

                    playerDied = TRUE
                    sammy(a).alive = FALSE
                    sammy(a).lives = sammy(a).lives - 1

                'Otherwise, move the snake, and erase the tail
                ELSE
                    sammy(a).head = (sammy(a).head + 1) MOD MAXSNAKELENGTH
                    sammyBody(sammy(a).head, a).Row = sammy(a).Row
                    sammyBody(sammy(a).head, a).Col = sammy(a).Col
                    tail = (sammy(a).head + MAXSNAKELENGTH - sammy(a).length) MOD MAXSNAKELENGTH
                    Set sammyBody(tail, a).Row, sammyBody(tail, a).Col, colortable(4)
                    sammyBody(tail, a).Row = 0
                    Set sammy(a).Row, sammy(a).Col, sammy(a).scolor
                END IF
            NEXT a

        LOOP UNTIL playerDied

        CurSpeed = rspeed                ' reset rspeed to initial value

        FOR a = 1 TO NumPlayers
            EraseSnake sammy(), sammyBody(), a

            'If dead, then erase snake in really cool way
            IF sammy(a).alive = FALSE THEN
                'Update score
                sammy(a).score = sammy(a).score - 10
                PrintScore NumPlayers, sammy(1).score, sammy(2).score, sammy(1).lives, sammy(2).lives

                IF a = 1 THEN
                    SpacePause name1$ + " Dies! Push Space!"
                ELSE
                    SpacePause name2$ + " Dies! Push Space!"
                END IF
            END IF
        NEXT a

        Level SAMELEVEL, sammy()
        PrintScore NumPlayers, sammy(1).score, sammy(2).score, sammy(1).lives, sammy(2).lives

    'Play next round, until either of snake's lives have run out.
    LOOP UNTIL sammy(1).lives = 0 OR sammy(2).lives = 0

'------------- Aufruf des Highscore-Generators eingefgt, Antoni 9.7.99 ------

COLOR colortable(5), colortable(6)
center 10, ""
center 11, "       G A M E   O V E R       "
center 12, "                               "
center 13, "          Hit any Key          "
center 14, ""
WHILE INKEY$ = "": WEND

scr1& = sammy(1).score * 100     'bei den Scores Hunderterfaktoren einberechnen
scr2& = sammy(2).score * 100     '... und Typenwandlung
IF NumPlayers = 1 THEN           'Single-Player Game
  CALL Top46(scr1&, 0, 0)        'Highscoreliste immer ausgeben ohne Playerno.
ELSE                             '2-Player Game
  CALL Top46(scr1&, 1, 1)        'Highscoreliste nur anzeigen, wenn Neueintrag
  CALL Top46(scr2&, 1, 2)        'Dito fr Player 2
END IF
COLOR , 1: CLS                   'blauer Bildschrirm fr Beenden-Kasten
'------------- Ende der Einfgung Antoni -------------------------------------

END SUB

'PointIsThere:
'  Checks the global  arena array to see if the boolean flag is set
FUNCTION PointIsThere (Row, Col, acolor)
    IF Row <> 0 THEN
        IF arena(Row, Col).acolor <> acolor THEN
            PointIsThere = TRUE
        ELSE
            PointIsThere = FALSE
        END IF
    END IF
END FUNCTION

'PrintScore:
'  Prints players scores and number of lives remaining
SUB PrintScore (NumPlayers, score1, score2, lives1, lives2)
    COLOR 15, colortable(4)

    IF NumPlayers = 2 THEN
        LOCATE 1, 1
        PRINT USING "#,###,#00  Lives: #  <- "; score2; lives2; : PRINT name2$;
    END IF

    LOCATE 1, 45: PRINT name1$;
    LOCATE 1, 59: PRINT USING " -> Lives: # #,###,#00"; lives1; score1
END SUB

SUB ReadConfigFile

nr = FREEFILE
OPEN "nibblesM.ini" FOR BINARY AS #nr
FOR i = 1 TO 6: GET #nr, , config(i): NEXT
CLOSE nr
                
InitNoise VAL(config(5))
SetColors VAL(config(6))

END SUB

'-------------------------------- Speichert Eingaben in der Variablen config()
SUB saveconfig (zeile, eingabe$)

IF eingabe$ = "" THEN EXIT SUB
IF zeile = 21 THEN EXIT SUB
config(INT(zeile * .5) - 3) = eingabe$

END SUB

'Set:
'  Sets row and column on playing field to given color to facilitate moving
'  of snakes around the field.
SUB Set (Row, Col, acolor)
    IF Row <> 0 THEN
        arena(Row, Col).acolor = acolor             'assign color to arena
        realRow = arena(Row, Col).realRow           'Get real row of pixel
        topFlag = arena(Row, Col).sister + 1 / 2    'Deduce whether pixel
                                                    'is on top, or bottom
        sisterRow = Row + arena(Row, Col).sister    'Get arena row of sister
        sisterColor = arena(sisterRow, Col).acolor  'Determine sister's color

        LOCATE realRow, Col

        IF acolor = sisterColor THEN                'If both points are same
            COLOR acolor, acolor                           'Print chr$(219) ""
            PRINT CHR$(219);
        ELSE
            IF topFlag THEN                         'Since you cannot have
                IF acolor > 7 THEN                  'bright backgrounds
                    COLOR acolor, sisterColor       'determine best combo
                    PRINT CHR$(223);                'to use.
                ELSE
                    COLOR sisterColor, acolor
                    PRINT CHR$(220);
                END IF
            ELSE
                IF acolor > 7 THEN
                    COLOR acolor, sisterColor
                    PRINT CHR$(220);
                ELSE
                    COLOR sisterColor, acolor
                    PRINT CHR$(223);
                END IF
            END IF
        END IF
    END IF
END SUB

SUB SetColors (monitor)

'-------------------------------------------------------------------------
'Meaning of UseThisColours$:
'         snake1  snake2  (snake3)  Walls  Background  Dialogs-Fore  -Back
'mono:     15,     7,                7,       0,          15,          0
'normal:   14,     13,               12,      1,          15,          4
'-------------------------------------------------------------------------

    SELECT CASE monitor
          CASE 0
                SCREEN 0, 0
                UseThisColours$ = "150707001500"
          CASE 1
                SCREEN 0, 1
                UseThisColours$ = "141312011504"
          CASE ELSE
                SCREEN 0, 1
                UseThisColours$ = "141312011504"
                GOSUB TryNewColours
    END SELECT

    FOR a = 1 TO 6
    colortable(a) = VAL(MID$(UseThisColours$, 2 * a - 1, 2))
    NEXT a

EXIT SUB

TryNewColours: '----------------------------------------------------------
'-------------------------------------------------------------------------
    ChangeColor 0, 12, 25, 35
    ChangeColor 1, 5, 31, 42
    ChangeColor 4, 15, 33, 52
    ChangeColor 7, 40, 44, 44
'   ChangeColor 0, 60, 45, 15       'yolk-colour
    RETURN

END SUB

SUB ShowCredits
'***************************************************************************
' ShowCredits = Show a Credit screen of the Millennium Edition  (c)T.Antoni
'***************************************************************************
COLOR 14, 1          'Yellow text on blue background
CLS
PRINT "      Ŀ  "
PRINT "                                                                     "
PRINT "         The Innovative Features of the Nibbles Millenium Edition    "
PRINT "             "
PRINT "         This is  the  year  2000  Millennium  Edition based on the  "
PRINT "         legendary original Microsoft Nibbles game of the year 1991. "
PRINT "         The  following   innovative  features   have  been   added: "
PRINT "         - Highscore list, saved in the file NIBBLESM.SCR            "
PRINT "                                (c) Thomas Antoni, 1999              "
PRINT "         - Configuration Menu. The configuration is saved in the     "
PRINT "             file NIBBLESM.INI  (c) PZ, 2000                         "
PRINT "         - Automatic adaption to the CPU speed. Nibbles can now      "
PRINT "             be run at computers with speeds up to many GHz !        "
PRINT "             (the old version crashed at computers with speed        "
PRINT "              above 66 MHz)     (c) PZ, 2000                         "
PRINT "                                                                     "
PRINT "         Enjoy the power of QBasic and don't hesitate to contact     "
PRINT "         the innovators and enthusiastic Nibbles & QBasic fans       "
PRINT "         - PZ,  Email: p.z@freenet.de                                "
PRINT "         - Thomas Antoni, E-Mail: thomas@antonis.de ; visit my       "
PRINT "           homepage at     http://www.antonis.de                     "
PRINT "             The Hottest QBasic Stuff on Earth !!!       "
PRINT "      ٱ";
PRINT "        ";
DO: LOOP UNTIL INKEY$ <> ""

END SUB

'SpacePause:
'  Pauses game play and waits for space bar to be pressed before continuing
SUB SpacePause (text$)

    COLOR colortable(5), colortable(6)
    center 11, ""
    center 12, "" + SPACE$(34) + "": center 12, text$
    center 13, ""
    COLOR colortable(3), colortable(4)

     DO
      center 1, " " + LEFT$(TIME$, 5) + " "
      a$ = INKEY$
        SELECT CASE a$                                'Wait for
          CASE CHR$(27)                               'Escape
                END                                   'or
          CASE CHR$(32)                               'Space
                EXIT DO
        END SELECT
     LOOP

    COLOR 15, colortable(4)

    FOR i = 21 TO 26            ' Restore the screen background
        FOR j = 23 TO 58
            Set i, j, arena(i, j).acolor
        NEXT j
    NEXT i

END SUB

'SparklePause:
'  Creates flashing border for intro screen
SUB SparklePause


'~~~~~~~~


    COLOR 14, 0
    a$ = "*    *    *    *    *    *    *    *    *    *    *    *    *    *    *    *    *    "
    WHILE INKEY$ <> "": WEND 'Clear keyboard buffer

    DO ' Commentd out (c)T.Antoni -- old code: --  WHILE INKEY$ = ""
        FOR a = 1 TO 5
            LOCATE 1, 1                             'print horizontal sparkles
            PRINT MID$(a$, a, 80);
            LOCATE 22, 1
            PRINT MID$(a$, 6 - a, 80);

            FOR b = 2 TO 21                         'Print Vertical sparkles
                c = (a + b) MOD 5
                IF c = 1 THEN
                    LOCATE b, 80
                    PRINT "*";
                    LOCATE 23 - b, 1
                    PRINT "*";
                ELSE
                    LOCATE b, 80
                    PRINT " ";
                    LOCATE 23 - b, 1
                    PRINT " ";
                END IF
            NEXT b
        NEXT a
'*********** Insertion (c) T.Antoni, 13.10-2000 *****************
        key$ = INKEY$
        IF key$ = CHR$(0) + CHR$(59) THEN 'F1-Key depressed?
          ShowCredits                'Display credits of Millennium Edition
          EXIT SUB
          ELSEIF key$ <> "" THEN
            EXIT SUB
        END IF
        LOOP
'**************** end of insertion T.Antoni *********************
   
    '*** - Commented out (c) T.Antoni --- old code:--- WEND

END SUB

SUB Spread (text$, Row%, Col%, Delay)
'*******************************************************************************
'* SPRED - Inserted (c) Thomas Antoni, 13.10.2000
'* Spreads text on the screen in both directions starting from the specified  *
'*  coordinates.  Delay is measured in 100ths of a second (c) Matthew R. Usner                      *
'*******************************************************************************
d! = Delay                  'convert delay to single precision
IF d! < 1 THEN d! = 5       'always have at least 1/20 sec. delay
d! = d! / 100               'change to 100ths
IF text$ = "" THEN EXIT SUB 'if null, get out
Txt$ = text$
IF LEN(Txt$) MOD 2 = 1 THEN Txt$ = Txt$ + " "  'make text length even if odd
LeftSide$ = LEFT$(Txt$, LEN(Txt$) \ 2) 'divide text into left and right sides
RightSide$ = RIGHT$(Txt$, LEN(Txt$) \ 2)
FOR X% = 1 TO LEN(RightSide$)
  LOCATE Row%, Col%
  PRINT RIGHT$(RightSide$, X%);            'print a letter from the left side
    IF (Col% - X%) >= 1 THEN
      LOCATE Row%, Col% - X%
      PRINT LEFT$(LeftSide$, X%);
    END IF
  CurrentTimer! = TIMER
  WHILE TIMER < (CurrentTimer! + d!): WEND 'Wait for timer to increase by d!
  IF INKEY$ <> "" THEN d! = 0              'if a key is pressed, stop delaying
NEXT X%
END SUB

'StillWantsToPlay:
'  Determines if users want to play game again.
FUNCTION StillWantsToPlay
   
    COLOR colortable(5), colortable(6)
    center 10, ""
    center 11, "       G A M E   O V E R       "
    center 12, "                               "
    center 13, "      Play Again?   (Y/N)      "
    center 14, ""

    WHILE INKEY$ <> "": WEND
    DO
        kbd$ = UCASE$(INKEY$)
    LOOP UNTIL kbd$ = "Y" OR kbd$ = "N"

    COLOR 15, colortable(4)
    center 10, "                                 "
    center 11, "                                 "
    center 12, "                                 "
    center 13, "                                 "
    center 14, "                                 "

    IF kbd$ = "Y" THEN
        StillWantsToPlay = TRUE
    ELSE
        StillWantsToPlay = FALSE
        COLOR 7, 0
        CLS
    END IF

END FUNCTION

DEFSNG A-Z
SUB Top46 (score&, hiscoreonly%, playerno%)
'***************************************************************************
' TOP46 - QBasic-Subroutine for generating a highscore sreen
' ====================================================================
' The 46 highest scores are displayed on a highscore screen and
' saved in a highscore file. The name of this highscore file is re-definable
' via the CONST statement directly below this comment box.
'
' Subroutine parameters:
'  - score&       = actual score, value range 0...99,999,999
'  - hiscoreonly% = 0=highscore screen is displayed with each call of TOP46
'                   1=highscore screen is only displayed when a new entry
'                     in the highscore list is made
'  - playerno%    = Player-No
'                    0     = Single Player Game
'                    1...9 = Player-No in case of a muliplayer game, is
'                            used to designate the player in the name input
'                            dialog box
'
' (c) Thomas Antoni, 09.07.99 - 13.07.99
'***************************************************************************

CONST scorefile$ = "nibblesm.scr"    'Name der Hiscore-Datei, bei Namensnde-
                                     'rung nur diese Zeile modifizieren

DIM scorelist(1 TO 46) AS hiscore    'Hiscoreliste; Typdeklarat.i.Hauptprogr.

d$ = DATE$             'heutiges Datum im Format "dd.mm.jj" und "dd.mm.jjjj"
datum$ = MID$(d$, 4, 2) + "." + LEFT$(d$, 2) + "." + RIGHT$(d$, 2)
datumlang$ = MID$(d$, 4, 2) + "." + LEFT$(d$, 2) + "." + RIGHT$(d$, 4)

'------------- Hiscore-Datei in Hiscore-Feld einlesen ----------------------
OPEN scorefile$ FOR RANDOM AS #1 LEN = 28 'Hiscore-Datei ffnen

FOR i% = 1 TO 46                      'alle Datenstze von Hiscore-Datei in
  GET #1, i%, scorelist(i%)           'Hiscore-Feld einlesen
NEXT i%
CLOSE #1

'------- Hiscore-Feld und -Datei initialisieren falls Datei ------------------
'------- noch nicht existent                                ------------------
IF scorelist(1).points = 0 THEN       'Existiert d.Hiscore-Datei noch nicht?
  OPEN scorefile$ FOR RANDOM AS #1 LEN = 28
  FOR i% = 1 TO 46                    'Hiscore-Liste initialisieren
    scorelist(i%).rank = i%
    scorelist(i%).nam = SPACE$(14)    'Name=Blanks
    scorelist(i%).points = 0          '0 Punkte
    scorelist(i%).date = SPACE$(8)    'Datum=Leerzeichen
    PUT #1, i%, scorelist(i%)         'Datensatz in Hiscoredatei schreiben
  NEXT i%
  CLOSE #1
END IF

'---------- Falls neuer Hiscore: Playernamens-Eingabe vorbereiten ------------
IF score& > 99999999 THEN score& = 99999999 'Score auf 8 Stellen begrenzen
newhiscore% = 0                'Vorbesetzung: aktueller score ist kein hiscore

FOR i% = 1 TO 46
  IF score& > scorelist(i%).points THEN 'Hiscore-Eintrag fllig
  
    newhiscore% = 1            'Neuer Highscore-Eintrag ==> Jubelsound
    PLAY noise(5)
    COLOR 1, 1
    CLS                               'Bildschirm blau einfrben

    COLOR 15, 4                       'wei auf roten Kasten fr
    LOCATE 7, 15                      'Namensdialog malen
    PRINT ""; STRING$(48, ""); ""
    FOR y% = 8 TO 18
    LOCATE y%, 15
    PRINT ""; SPACE$(48); ""
    NEXT y%
    LOCATE , 15
    PRINT ""; STRING$(48, ""); ""
                               
    IF playerno% = 0 THEN             'String fr Playernummer erzeugen
    player$ = ""
    ELSE
      IF playerno% > 9 THEN playerno% = 9
      player$ = "PLAYER" + STR$(playerno%)
    END IF

    LOCATE 9, 21:  PRINT "Herzlichen Glckwunsch, "; player$; " !!!"
    LOCATE 11, 21: PRINT "Du hast"; score&; " Punkte und kannst"
    LOCATE 12, 21: PRINT "Dich in die Highscore-Liste eintragen."
    LOCATE 14, 21: PRINT "Wie lautet Dein Name?"
    LOCATE 16, 23: PRINT player$;
    IF playerno% > 0 THEN PRINT " ="
    LOCATE 17, 34: PRINT ".............."
    LOCATE 18, 31: PRINT "(maximal 14 Zeichen)"

'---------- Namenseingabedialog in auf 14 Zeichen begrenztem Feld ------------
    COLOR 14, 1 'gelb auf blau
    text$ = "": key$ = ""

    DO
'--------- Enter-Taste bearbeiten ------------------------
      IF key$ = CHR$(13) THEN EXIT DO            'Ende wenn Enter bettigt

'--------- Backspace-Taste bearbeiten --------------------
      IF key$ = CHR$(8) AND LEN(text$) > 0 THEN  'Backspace und Textlnge > 0 ?
        text$ = LEFT$(text$, LEN(text$) - 1)     'Text um 1 Zeichen krzen

'--------- andere Tasten bearbeiten ----------------------
      ELSEIF key$ > CHR$(29) AND key$ < CHR$(255) THEN 'alphanum. Taste?
        IF LEN(text$) = 14 THEN    'Text hat schon die volle Lnge ==> letztes
          text$ = LEFT$(text$, LEN(text$) - 1) + key$  'Zeichen austauschen
        ELSE
          text$ = text$ + key$         'ansonsten Tastenzeichen anfgen
        END IF
      END IF
'--------- text$ + Cursor auf Bildschirm ausgeben ------
      LOCATE 16, 34: PRINT SPACE$(14); 'Eingabefeld lschen/blau frben
      LOCATE , 34: PRINT text$;                  'Text ausgeben
      IF LEN(text$) < 14 THEN csrpos% = POS(0) ELSE csrpos% = POS(0) - 1
      LOCATE 16 + 1, csrpos%, 1, 0, 2  'Cursor in Pixelzeilen 0-3 der darunter-
                                       'liegenden Zeile blinkend ausgeben
      DO: key$ = INKEY$: LOOP WHILE key$ = ""    'warten bis Taste bettigt
    LOOP
    LOCATE , , 0, 7, 8                 'Cursor wieder deaktivieren
    neuername$ = text$

'----------- neuen Highscore in Hiscore-Feld eintragen ----------------------

    FOR k% = 45 TO i% STEP -1         'alle Eintrge mit kleinerem Score um
                                      'einen Listenplatz nach unten schieben
      scorelist(k% + 1).nam = scorelist(k%).nam
      scorelist(k% + 1).points = scorelist(k%).points
      scorelist(k% + 1).date = scorelist(k%).date
    NEXT k%

    scorelist(i%).nam = neuername$    'neuen Eintrag vornehmen
    scorelist(i%).points = score&
    scorelist(i%).date = datum$

'--------------- neue Hiscore-Liste auf den Bildschirm ausgeben -------------

    COLOR 0, 7: CLS                   'schwarz auf hellgrau
    FOR y% = 2 TO 24                  'linke Spalte (Platz 1-23) ausgeben
      LOCATE y%, 2
      platz% = y% - 1
      IF platz% = i% THEN
        COLOR 15, 2                   'neuen Eintrag wei auf grn highlighten
      ELSE
        COLOR 0, 7                    'Normalfarbe = schwarz auf hellgrau
      END IF
      GOSUB ShowScore                 'local subroutine at the bottom
    NEXT y%

    FOR y% = 2 TO 24                  'rechte Spalte (Platz 24-46) ausgeben
      LOCATE y%, 40
      COLOR 0, 7
      PRINT " ";
      platz% = y% + 22
      IF platz% = i% THEN COLOR 15, 2 'neuen Eintrag wei auf grn highlighten
      GOSUB ShowScore
    NEXT y%

    kopftext$ = "COOL !  " + RTRIM$(scorelist(i%).nam) + ": Du hast" + STR$(score&) + " Punkte und somit einen Highscore"
    GOSUB KopfFussZeile          'Lokale Sub: Kopfzeile mit Begrung u. Fu-
                                 'zeile mit Beenden-Dialog anzeigen

'--------------- neue Hiscore-Liste ins Hiscore-File transferieren -------------

    OPEN scorefile$ FOR RANDOM AS #1 LEN = 28

    FOR n = 1 TO 46
      PUT #1, n, scorelist(n)
    NEXT n

    CLOSE #1
    EXIT FOR

  END IF
NEXT i%

'------------- auch bei nicht erreichtem Eintrag Highscore anzeigen ----------
'------------- wenn  hiscoreonly%=0                                 ----------

IF (newhiscore% = 0) AND (hiscoreonly% = 0) THEN
  PLAY noise(6)                     'Trauersound, weil kein Eintrag
  COLOR 0, 7: CLS                   'schwarz auf hellgrau
  FOR y% = 2 TO 24                  'linke Spalte (Platz 1-23) ausgeben
    LOCATE y%, 2
    platz% = y% - 1
    GOSUB ShowScore
  NEXT y%

  FOR y% = 2 TO 24                  'rechte Spalte (Platz 24-46 ausgeben
    LOCATE y%, 40
    PRINT " ";
    platz% = y% + 22
    GOSUB ShowScore
  NEXT y%

  kopftext$ = "Du hast" + STR$(score&) + " Punkte. Sorry - leider kein Highscore!"
GOSUB KopfFussZeile                  'Kopf- und Fuzeile ausgeben
END IF
GOTO top46end                        'Aussprung aus der SUB TOP46

'------------- Lokale Subroutine ShowScore zum Anzeigen des      ------------
'------------- Hiscore-Eintrags auf dem Rang platz%               ------------

ShowScore:
  PRINT USING "##"; scorelist(platz%).rank;
  PRINT ". "; scorelist(platz%).nam; " ";
  PRINT USING "########"; scorelist(platz%).points;
  PRINT "  "; scorelist(platz%).date;
RETURN

'--------- KopfFussZeile: Lokale Subroutine z.Anzeigen von Kopf- -------------
'--------- und Fuzeile mit Drehbalken, Beendigungshinweis u.Uhrzeit ---------
KopfFussZeile:
LOCATE 1, 1                          'Kopfzeile mit Begrungstext
COLOR 15, 4                          'Kopfzeile rot einfrben
PRINT SPACE$(80)
LOCATE 1, (80 - LEN(kopftext$)) / 2  'Kopfzeile mittig anzeigen
PRINT kopftext$

LOCATE 25, 1                          'Fuzeile
PRINT "         Beenden: Beliebige Taste                                             ";
BEEP
DO
  taste$ = INKEY$
  StartTime! = TIMER
  DO: LOOP UNTIL TIMER > StartTime! + .15     '150 ms Wartezeit
  LOCATE , 57
  PRINT " "; datumlang$; "  "; TIME$;  'Uhrzeit + Datum anzeigen
  LOCATE , 2                             'Drehbalken als Ttigkeitsanzeige
  k% = k% + 1
  IF k% > 4 THEN k% = 1
  SELECT CASE k%
    CASE 1: PRINT "";
    CASE 2: PRINT "\";
    CASE 3: PRINT "";
    CASE 4: PRINT "/";
  END SELECT
LOOP WHILE taste$ = ""
COLOR 15, 0: CLS                         'wieder wei/schwarz-Bildschirm
RETURN

top46end:
END SUB

DEFINT A-Z
SUB twinkle STATIC
DIM n(0 TO 70) AS INTEGER
DEF SEG = &HB800

'------------------------------------------------ twinkle N's ------------
i = INT(4000 * RND)
IF PEEK(2 * i) = 78 THEN                    'select "N"
        POKE 2 * n(0) + 1, 120              'reset colour
        POKE 2 * i + 1, 126                 'set yellow
        POKE 2 * n(65) + 1, 124             'change to red
          FOR z = 0 TO 69                   'rotate i
            n(z) = n(z + 1)
          NEXT z
        n(70) = i                           'save i
END IF



'------------------------------------------------ twinkle 4 colours -------
'i = INT(4000 * RND): POKE 2 * i + 1, 7
'i = INT(4000 * RND): POKE 2 * i + 1, 15
'i = INT(4000 * RND): POKE 2 * i + 1, 12
'i = INT(4000 * RND): POKE 2 * i + 1, 9

DEF SEG
END SUB

SUB version
'
'------------------ Modifikationen von T.Antoni 21.03.99 - 09.07.99 ---------
'------------------ thomas.antoni@erlf.siemens.de                   ---------

' 1. Sub GetInput: Division durch 0 abgefangen bei Speed-Ermittlung fr
'    Pentium-Rechner
' 2. Jeweils an 2 Stellen Spielername "Jake" durch " TOM" und "SAMMY" durch
'    "MARC " ersetzt
' 3. Sub Intro: "Cracked by Thomas Antoni" eingefgt
' 4. Hauptprogramm: in d.Mitte "End" auskommentiert u.durch "SYSTEM" ersetzt
' 5. SUB GetInputs: bei Spacetaste wird sofort die normale Konfiguration gltig
'                   (2Player, Speed=1, Autoincrease Speed, Color Monitor
'                    2 Einfgungen hineineditiert)
' 6. Nummernfressen- und Sterbesound in SUB PlayNibbles ab ca. Zeile 85
'    gendert
' 7. Highscore-Generator TOP46 eingefgt 09.07.99:
'     a) user-defined TYPE highscore gleich unten eingefgt
'     b) Aufruf der Subroutine TOP46 in der SUB "PlayNibbles" unten eingefgt
'     c) SUBroutine TOP46 eingefgt + Deklaration im Main Modul
'
'
' Diverse nderungen 22.08.2000 durch pz
' ---------------------------------------------------------------------------
'
' ClearKeyLocks/RestoreKeyLocks auskommentiert (main)
' Sub GetInputs durch Sub GetInput ersetzt, darin:
'  - Voreinstellungen werden in INI-Datei gespeichert
'  - SystemSpeed wird durch Bildschirmausgaben (5000 * TIME$) ermittelt
' Spiel wird durch Bildschirmausgaben (speed * TIME$) verzgert (PlayNibbles)
' Sound kann abgeschaltet werden (alle PLAY-Anweisungen gendert)
' Spielernamen durch Variable ersetzt (PrintScore)
' Fehler bei "Autoincrease" Speed beibehalten (war und ist deaktiviert)
'
' nderungen 08.09.2000 durch pz
' ---------------------------------------------------------------------------
' Sound in Intro reaktiviert ("IF noise THEN ... " gelscht)
' Nummernfressen-Sound in PlayNibbles um Anweisung "MB" ergnzt.
'
' nderungen 14.09.2000 durch pz
' ---------------------------------------------------------------------------
' MessageBox erweitert, um Spielernamen mit 14 max. Zeichen auszugeben,
'   dazu Subs SpacePause und center gendert
' Hintergrund-Variante in Sub GetInput eingefgt
' Neue Sub InitNoise enthlt whlbare Sounds, alle PLAY-Anweisungen angepasst
' Neue Sub ChangeColor ermglicht mehr als tausend Farben
' Neue Formel zur Speed-Anpassung in Sub GetInput
'
' nderungen 28.09.2000 durch pz
' ---------------------------------------------------------------------------
' Hintergrund-Variante in Sub GetInput erweitert (neue Sub twinkle)
' Spielabbruch mit Escape ermglicht (Sub PlayNibbles und SpacePause)
' Erweiterte Farbeinstellungen in Sub SetColors zusammengefasst
' Lesen der Konfigurationsdatei jetzt vor der Intro (neue Sub ReadConfigFile)
' Formel zur Speedanpassung gendert
' AutoIncrease aktiviert, dazu Variable diff$ durch xlr8 (sprich accelerate)
'   ersetzt (in GetInput und PlayNibbles)
' Variable speed in rspeed umbenannt (um zu verdeutlichen, da es sich hier
'   nicht um Geschwindigkeit, sondern um Warteschleifen handelt)
'
END SUB

